| The Gaudi Framework v30r0 (c919700c)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
IoComponentMgr Class Reference

`#include <src/component/IoComponentMgr.h>`

Inheritance diagram for IoComponentMgr:
[legend]
Collaboration diagram for IoComponentMgr:
[legend]

## Classes
struct | IoComponentEntry

## Public Member Functions
| ~IoComponentMgr () override=default
| Destructor: More...
void | handle (const Incident &) override
bool | io_hasitem (IIoComponent *iocomponent) const override
| : check if the registry contains a given `IIoComponent` More...
bool | io_contains (IIoComponent *iocomponent, const std::string &fname) const override
| : check if the registry contains a given `IIoComponent` and that component had More...
StatusCode | io_register (IIoComponent *iocomponent) override
| : allow a `IIoComponent` to register itself with this manager so appropriate actions can be taken when e.g. More...
StatusCode | io_register (IIoComponent *iocomponent, IIoComponentMgr::IoMode::Type iomode, const std::string &fname, const std::string &pfn) override
| : allow a `IIoComponent` to register itself with this manager so appropriate actions can be taken when e.g. More...
StatusCode | io_update (IIoComponent *iocomponent, const std::string &old_fname, const std::string &new_fname) override
| : allow a `IIoComponent` to update the contents of the registry with a new file name More...
StatusCode | io_update (IIoComponent *iocomponent, const std::string &work_dir) override
| : allow a `IIoComponent` to update the contents of the registry with a new work directory More...
StatusCode | io_update_all (const std::string &work_dir) override
| : Update all `IIoComponents` with a new work directory More...
StatusCode | io_retrieve (IIoComponent *iocomponent, std::string &fname) override
| : retrieve the new filename for a given `IIoComponent` and More...
StatusCode | io_reinitialize () override
| : reinitialize the I/O subsystem. More...
StatusCode | io_finalize () override
| : finalize the I/O subsystem. More...
StatusCode | initialize () override
| Gaudi Service Implementation. More...
StatusCode | finalize () override
Public Member Functions inherited from extends< Service, IIoComponentMgr, IIncidentListener >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Types
typedef std::map< std::string, IIoComponent * > | IoRegistry_t
typedef std::list< IIoComponent * > | IoStack_t
typedef std::multimap< IIoComponent *, IoComponentEntry > | IoDict_t
typedef IoDict_t::const_iterator | iodITR

## Private Member Functions
| IoComponentMgr ()=delete
| Default constructor: More...
bool | findComp (IIoComponent *, const std::string &, iodITR &) const
bool | findComp (IIoComponent *, std::pair< iodITR, iodITR > &) const
bool | findComp (const std::string &, std::pair< iodITR, iodITR > &) const
std::string | list () const

## Private Attributes
IoRegistry_t | m_ioregistry
| Registry of `IIoComponents`. More...
IoStack_t | m_iostack
| Stack of `IIoComponents` to properly handle order of registration. More...
IoDict_t | m_cdict
std::string | m_dict_location
| location of the python dictionary More...

## Additional Inherited Members
Public Types inherited from extends< Service, IIoComponentMgr, IIncidentListener >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 28 of file IoComponentMgr.h.

## Member Typedef Documentation

typedef std::multimap<IIoComponent*, IoComponentEntry> IoComponentMgr::IoDict_t
| private

Definition at line 175 of file IoComponentMgr.h.

typedef IoDict_t::const_iterator IoComponentMgr::iodITR
| private

Definition at line 176 of file IoComponentMgr.h.

typedef std::map<std::string, IIoComponent*> IoComponentMgr::IoRegistry_t
| private

Definition at line 166 of file IoComponentMgr.h.

typedef std::list<IIoComponent*> IoComponentMgr::IoStack_t
| private

Definition at line 170 of file IoComponentMgr.h.

## Constructor & Destructor Documentation

IoComponentMgr::~IoComponentMgr | ( |  | ) |
| override default

Destructor:

IoComponentMgr::IoComponentMgr | ( |  | ) |
| private delete

Default constructor:

## Member Function Documentation

StatusCode IoComponentMgr::finalize | ( |  | ) |
| override

Definition at line 78 of file IoComponentMgr.cpp.

79 {
80 DEBMSG << "--> finalize()" << endmsg;
81
82 return StatusCode::SUCCESS;
83 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

bool IoComponentMgr::findComp | ( | IIoComponent * | c,
|  | const std::string & | f,
|  | iodITR & | itr
| ) |  | const
| private

Definition at line 410 of file IoComponentMgr.cpp.

411 {
412
413 pair<iodITR, iodITR> pit;
414 if ( !findComp( c, pit ) ) {
415 itr = pit.first;
416 return false;
417 }
418 return std::any_of( pit.first, pit.second, [&]( IoDict_t::const_reference i ) { return i.second.m_oldfname == f; } );
419 }
IoComponentMgr::findComp
bool findComp(IIoComponent *, const std::string &, iodITR &) const
Definition: IoComponentMgr.cpp:410
std::pair
std::any_of
T any_of(T...args)

bool IoComponentMgr::findComp | ( | IIoComponent * | c,
|  | std::pair< iodITR, iodITR > & | pit
| ) |  | const
| private

Definition at line 423 of file IoComponentMgr.cpp.

424 {
425
426 pit = m_cdict.equal_range( c );
427 return pit.first != pit.second;
428 }
std::multimap::equal_range
T equal_range(T...args)
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

bool IoComponentMgr::findComp | ( | const std::string & | c,
|  | std::pair< iodITR, iodITR > & | pit
| ) |  | const
| private

Definition at line 432 of file IoComponentMgr.cpp.

433 {
434
435 pit.first = m_cdict.end();
436 pit.second = m_cdict.end();
437
438 auto itr = m_ioregistry.find( c );
439 return ( itr != m_ioregistry.end() ) && findComp( itr->second, pit );
440 }
IoComponentMgr::m_ioregistry
IoRegistry_t m_ioregistry
Registry of IIoComponents.
Definition: IoComponentMgr.h:168
std::multimap::end
T end(T...args)
IoComponentMgr::findComp
bool findComp(IIoComponent *, const std::string &, iodITR &) const
Definition: IoComponentMgr.cpp:410
std::map::find
T find(T...args)
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

void IoComponentMgr::handle | ( | const Incident & | i | ) |
| override

Definition at line 459 of file IoComponentMgr.cpp.

460 {
461
462 pair<iodITR, iodITR> pit;
463
464 if ( i.type() == IncidentType::BeginInputFile ) {
465
466 const FileIncident* fi = dynamic_cast<const FileIncident*>( &i );
467 DEBMSG << "BeginInputFile: s: " << fi->source() << " t: " << fi->type() << " n: " << fi->fileName()
468 << " g: " << fi->fileGuid() << endmsg;
469
470 if ( findComp( fi->source(), pit ) ) {
471 DEBMSG << " found component: " << endmsg;
472 while ( pit.first != pit.second ) {
473 IIoComponent* c = pit.first->first;
474 IoComponentEntry e = pit.first->second;
475 DEBMSG << " c: " << c->name() << " " << e << endmsg;
476
477 ++pit.first;
478 }
479 } else {
480 DEBMSG << " could not find component \"" << fi->source() << "\"!" << endmsg;
481 }
482
483 } else if ( i.type() == IncidentType::BeginOutputFile ) {
484
485 const FileIncident* fi = dynamic_cast<const FileIncident*>( &i );
486 DEBMSG << "BeginOutputFile: s: " << fi->source() << " t: " << fi->type() << " n: " << fi->fileName()
487 << " g: " << fi->fileGuid() << endmsg;
488
489 if ( findComp( fi->source(), pit ) ) {
490 DEBMSG << " found component: " << endmsg;
491 while ( pit.first != pit.second ) {
492 IIoComponent* c = pit.first->first;
493 IoComponentEntry e = pit.first->second;
494 DEBMSG << " c: " << c->name() << " " << e << endmsg;
495
496 ++pit.first;
497 }
498 } else {
499 DEBMSG << " could not find component \"" << fi->source() << "\"!" << endmsg;
500 }
501 }
502 }
IIoComponent
Definition: IIoComponent.h:16
FileIncident
This class is the FileIncident.
Definition: FileIncident.h:17
gaudirun.c
c
Definition: gaudirun.py:407
Incident::type
const std::string & type() const
Access to the incident type.
Definition: Incident.h:41
Incident::source
const std::string & source() const
Access to the source of the incident.
Definition: Incident.h:47
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
IoComponentMgr::findComp
bool findComp(IIoComponent *, const std::string &, iodITR &) const
Definition: IoComponentMgr.cpp:410
std::pair
FileIncident::fileGuid
const std::string & fileGuid() const
Definition: FileIncident.h:62
FileIncident::fileName
const std::string & fileName() const
Definition: FileIncident.h:61
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.

StatusCode IoComponentMgr::initialize | ( |  | ) |
| override

Gaudi Service Implementation.

Definition at line 54 of file IoComponentMgr.cpp.

55 {
56 DEBMSG << "--> initialize()" << endmsg;
57
58 if ( Service::initialize().isFailure() ) {
59 error() << "Unable to initialize Service base class" << endmsg;
60 return StatusCode::FAILURE;
61 }
62
63 IIncidentSvc* p_incSvc( 0 );
64
65 if ( service( "IncidentSvc", p_incSvc, true ).isFailure() ) {
66 error() << "unable to get the IncidentSvc" << endmsg;
67 return StatusCode::FAILURE;
68 } else {
69 p_incSvc->addListener( this, IncidentType::BeginOutputFile, 100, true );
70 p_incSvc->addListener( this, IncidentType::BeginInputFile, 100, true );
71 }
72
73 return StatusCode::SUCCESS;
74 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
Service::service
StatusCode service(const std::string &name, const T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Service.h:85
StatusCode::FAILURE
Definition: StatusCode.h:29
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
IIncidentSvc
The interface implemented by the IncidentSvc service.
Definition: IIncidentSvc.h:23

bool IoComponentMgr::io_contains | ( | IIoComponent * | iocomponent,
|  | const std::string & | fname
| ) |  | const
| override

: check if the registry contains a given `IIoComponent` and that component had

Parameters

  <tt>fname</tt> | as a filename

Definition at line 105 of file IoComponentMgr.cpp.

106 {
107 DEBMSG << "--> io_contains()" << endmsg;
108 if ( 0 == iocomponent ) {
109 return false;
110 }
111 const std::string& ioname = iocomponent->name();
112
113 DEBMSG << "io_contains: c: " << ioname << " f: " << fname << endmsg;
114
115 pair<iodITR, iodITR> fit = m_cdict.equal_range( iocomponent );
116 if ( fit.first == fit.second ) {
117 return false;
118 } else {
119 iodITR it;
120 for ( it = fit.first; it != fit.second; ++it ) {
121 IoComponentEntry ioe = it->second;
122 DEBMSG << " " << ioe << endmsg;
123 if ( ioe.m_oldfname == "" ) {
124 error() << "IIoComponent " << ioname << " has empty old filename" << endmsg;
125 return false;
126 } else if ( ioe.m_oldfname == fname ) {
127 return true;
128 }
129 }
130 }
131
132 return false;
133 }
IoComponentMgr::iodITR
IoDict_t::const_iterator iodITR
Definition: IoComponentMgr.h:176
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
std::string
STL class.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
std::pair
std::multimap::equal_range
T equal_range(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

StatusCode IoComponentMgr::io_finalize | ( |  | ) |
| override

: finalize the I/O subsystem.

Hook to allow to e.g. give a chance to I/O subsystems to merge output files. Not sure how to do this correctly though...

Definition at line 385 of file IoComponentMgr.cpp.

386 {
387 ON_DEBUG
388 {
389 debug() << "--> io_finalize()" << endmsg;
390 debug() << "finalizing I/O subsystem..." << endmsg;
391 debug() << "Listing all monitored entries: " << std::endl;
392 debug() << list() << endmsg;
393 }
394
395 bool allgood = true;
396 // reverse iteration to unwind component dependencies
397 for ( IoStack_t::reverse_iterator io = m_iostack.rbegin(), ioEnd = m_iostack.rend(); io != ioEnd; ++io ) {
398 DEBMSG << " [" << ( *io )->name() << "]->io_finalize()..." << endmsg;
399 if ( !( *io )->io_finalize().isSuccess() ) {
400 allgood = false;
401 error() << "problem in [" << ( *io )->name() << "]->io_finalize() !" << endmsg;
402 }
403 }
404
405 return allgood ? StatusCode::SUCCESS : StatusCode::FAILURE;
406 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
std::list::rend
T rend(T...args)
std::endl
T endl(T...args)
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
IoComponentMgr::list
std::string list() const
Definition: IoComponentMgr.cpp:444
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
ON_DEBUG
#define ON_DEBUG
Definition: IoComponentMgr.cpp:22
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:115
StatusCode::FAILURE
Definition: StatusCode.h:29
IoComponentMgr::m_iostack
IoStack_t m_iostack
Stack of IIoComponents to properly handle order of registration.
Definition: IoComponentMgr.h:172
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
std::list::rbegin
T rbegin(T...args)

bool IoComponentMgr::io_hasitem | ( | IIoComponent * | iocomponent | ) | const
| override

: check if the registry contains a given `IIoComponent`

Definition at line 89 of file IoComponentMgr.cpp.

90 {
91 DEBMSG << "--> io_hasitem()" << endmsg;
92 if ( 0 == iocomponent ) {
93 return false;
94 }
95 const std::string& ioname = iocomponent->name();
96 IoRegistry_t::const_iterator io = m_ioregistry.find( ioname );
97 return io != m_ioregistry.end();
98 }
IoComponentMgr::m_ioregistry
IoRegistry_t m_ioregistry
Registry of IIoComponents.
Definition: IoComponentMgr.h:168
std::map::end
T end(T...args)
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
std::string
STL class.
std::map::find
T find(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.

StatusCode IoComponentMgr::io_register | ( | IIoComponent * | iocomponent | ) |
| override

: allow a `IIoComponent` to register itself with this manager so appropriate actions can be taken when e.g.

a `fork(2)` has been issued (this is usually handled by calling `IIoComponent::io_reinit` on every registered component)

Definition at line 143 of file IoComponentMgr.cpp.

144 {
145 if ( !iocomponent ) {
146 error() << "io_register (component) received a NULL pointer !" << endmsg;
147 return StatusCode::FAILURE;
148 }
149 const std::string& ioname = iocomponent->name();
150 DEBMSG << "--> io_register(" << ioname << ")" << endmsg;
151 auto itr = m_ioregistry.find( ioname );
152 if ( itr == m_ioregistry.end() ) {
153 DEBMSG << " registering IoComponent \"" << ioname << "\"" << endmsg;
154 iocomponent->addRef(); // ownership...
155 m_ioregistry[ioname] = iocomponent;
156 m_iostack.push_back( iocomponent );
157 } else {
158 info() << "IoComponent[" << iocomponent->name() << "] already registered @" << (void*)itr->second << endmsg;
159 }
160 return StatusCode::SUCCESS;
161 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:112
IoComponentMgr::m_ioregistry
IoRegistry_t m_ioregistry
Registry of IIoComponents.
Definition: IoComponentMgr.h:168
std::map::end
T end(T...args)
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
std::string
STL class.
std::list::push_back
T push_back(T...args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
std::map::find
T find(T...args)
IInterface::addRef
virtual unsigned long addRef()=0
Increment the reference count of Interface instance.
StatusCode::FAILURE
Definition: StatusCode.h:29
IoComponentMgr::m_iostack
IoStack_t m_iostack
Stack of IIoComponents to properly handle order of registration.
Definition: IoComponentMgr.h:172
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.

StatusCode IoComponentMgr::io_register | ( | IIoComponent * | iocomponent,
|  | IIoComponentMgr::IoMode::Type | iomode,
|  | const std::string & | fname,
|  | const std::string & | pfn
| ) |  |
| override

: allow a `IIoComponent` to register itself with this manager so appropriate actions can be taken when e.g.

a `fork(2)` has been issued (this is usually handled by calling `IIoComponent::io_reinit` on every registered component)

Definition at line 171 of file IoComponentMgr.cpp.

173 {
174 if ( 0 == iocomponent ) {
175 return StatusCode::FAILURE;
176 }
177 const std::string& ioname = iocomponent->name();
178
179 DEBMSG << "--> io_register(" << ioname << "," << ( ( iomode == IIoComponentMgr::IoMode::READ ) ? "R" : "W" ) << ","
180 << fname << ")" << endmsg;
181
182 if ( !io_hasitem( iocomponent ) ) {
183 if ( !io_register( iocomponent ).isSuccess() ) {
184 error() << "could not register component [" << iocomponent->name() << "] "
185 << "with the I/O component manager !" << endmsg;
186 return StatusCode::FAILURE;
187 }
188 }
189
190 pair<iodITR, iodITR> fit = m_cdict.equal_range( iocomponent );
191 if ( fit.first != fit.second ) {
192 for ( iodITR it = fit.first; it != fit.second; ++it ) {
193 IoComponentEntry ioe = it->second;
194 if ( ioe.m_oldfname == fname ) {
195 if ( ioe.m_iomode == iomode ) {
196 info() << "IoComponent " << ioname << " has already had file " << fname << " registered with i/o mode "
197 << iomode << endmsg;
198 return StatusCode::SUCCESS;
199 } else {
200 warning() << "IoComponent " << ioname << " has already had file " << fname
201 << " registered with a different i/o mode " << ioe.m_iomode << " - now trying " << iomode << endmsg;
202 }
203 }
204 }
205 }
206
207 // We need to take into account that boost::filesystem::absolute() does not work in following cases:
208 // 1. files read from eos, i.e. starting with "root:"
209 // 2. files read over http, i.e. starting either with 'http:' or with 'https:'
210 const std::string& tmp_name = ( pfn.empty() ? fname : pfn );
211 static const std::array<std::string, 4> prefixes = {"root:", "http:", "https:", "dcap:"};
212 bool special_case = std::any_of( begin( prefixes ), end( prefixes ), [&]( const std::string& pf ) {
213 return boost::algorithm::starts_with( tmp_name, pf );
214 } );
215 IoComponentEntry ioc( fname, ( special_case ? tmp_name : boost::filesystem::absolute( tmp_name ).string() ), iomode );
216 m_cdict.insert( pair<IIoComponent*, IoComponentEntry>( iocomponent, ioc ) );
217
218 return StatusCode::SUCCESS;
219 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
std::string::empty
T empty(T...args)
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:112
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:50
IoComponentMgr::iodITR
IoDict_t::const_iterator iodITR
Definition: IoComponentMgr.h:176
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
begin
auto begin(reverse_wrapper< T > &w)
Definition: reverse.h:58
std::string
STL class.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:109
IoComponentMgr::io_register
StatusCode io_register(IIoComponent *iocomponent) override
: allow a IIoComponent to register itself with this manager so appropriate actions can be taken when ...
Definition: IoComponentMgr.cpp:143
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:64
std::pair
std::multimap::insert
T insert(T...args)
std::any_of
T any_of(T...args)
std::array
STL class.
StatusCode::FAILURE
Definition: StatusCode.h:29
IIoComponentMgr::IoMode::READ
Definition: IIoComponentMgr.h:32
std::multimap::equal_range
T equal_range(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IoComponentMgr::io_hasitem
bool io_hasitem(IIoComponent *iocomponent) const override
: check if the registry contains a given IIoComponent
Definition: IoComponentMgr.cpp:89
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

StatusCode IoComponentMgr::io_reinitialize | ( |  | ) |
| override

: reinitialize the I/O subsystem.

This effectively calls `IIoComponent::io_reinit` on all the registered `IIoComponent`.

Definition at line 266 of file IoComponentMgr.cpp.

267 {
268 ON_DEBUG
269 {
270 debug() << "--> io_reinitialize()" << endmsg;
271 debug() << "reinitializing I/O subsystem..." << endmsg;
272 debug() << "Listing all monitored entries: " << std::endl;
273 debug() << list() << endmsg;
274 }
275
276 bool allgood = true;
277 for ( auto& io : m_iostack ) {
278 DEBMSG << " [" << io->name() << "]->io_reinit()..." << endmsg;
279 if ( !io->io_reinit().isSuccess() ) {
280 allgood = false;
281 error() << "problem in [" << io->name() << "]->io_reinit() !" << endmsg;
282 }
283 // we are done with this guy... release it
284 io->release();
285 }
286
287 // we are done.
288 // FIXME: shall we allow for multiple io_reinitialize ?
289 // m_iostack.clear();
290 // m_ioregistry.clear();
291 // m_cdict.clear();
292
293 return allgood ? StatusCode::SUCCESS : StatusCode::FAILURE;
294 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
std::endl
T endl(T...args)
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
IoComponentMgr::list
std::string list() const
Definition: IoComponentMgr.cpp:444
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
ON_DEBUG
#define ON_DEBUG
Definition: IoComponentMgr.cpp:22
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:115
StatusCode::FAILURE
Definition: StatusCode.h:29
IoComponentMgr::m_iostack
IoStack_t m_iostack
Stack of IIoComponents to properly handle order of registration.
Definition: IoComponentMgr.h:172
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

StatusCode IoComponentMgr::io_retrieve | ( | IIoComponent * | iocomponent,
|  | std::string & | fname
| ) |  |
| override

: retrieve the new filename for a given `IIoComponent` and

Parameters

  <tt>fname</tt> | filename
  <tt>oldfname</tt> | filename

Definition at line 226 of file IoComponentMgr.cpp.

227 {
228 if ( 0 == iocomponent ) {
229 return StatusCode::FAILURE;
230 }
231
232 std::string ofname = fname;
233 const std::string& ioname = iocomponent->name();
234
235 DEBMSG << "--> io_retrieve(" << ioname << "," << fname << ")" << endmsg;
236
237 iodITR it;
238 if ( !findComp( iocomponent, ofname, it ) ) {
239 DEBMSG << "could not find c: " << ioname << " old_f: " << ofname << endmsg;
240 return StatusCode::FAILURE;
241 } else {
242
243 IoDict_t::iterator it;
244 for ( it = m_cdict.equal_range( iocomponent ).first; it != m_cdict.equal_range( iocomponent ).second; ++it ) {
245
246 if ( it->second.m_oldfname == ofname ) {
247 DEBMSG << "retrieving new name for the component " << iocomponent->name() << " old name: " << ofname
248 << ", new name: " << it->second.m_newfname << endmsg;
249 fname = it->second.m_newfname;
250 return StatusCode::SUCCESS;
251 }
252 }
253 }
254
255 DEBMSG << "Unexpected error! Unable to find entry in the dictionary corresponding to old filename: " << ofname
256 << endmsg;
257 return StatusCode::FAILURE;
258 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
IoComponentMgr::iodITR
IoDict_t::const_iterator iodITR
Definition: IoComponentMgr.h:176
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
std::string
STL class.
IoComponentMgr::findComp
bool findComp(IIoComponent *, const std::string &, iodITR &) const
Definition: IoComponentMgr.cpp:410
StatusCode::FAILURE
Definition: StatusCode.h:29
std::multimap::equal_range
T equal_range(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

StatusCode IoComponentMgr::io_update | ( | IIoComponent * | iocomponent,
|  | const std::string & | old_fname,
|  | const std::string & | new_fname
| ) |  |
| override

: allow a `IIoComponent` to update the contents of the registry with a new file name

Definition at line 298 of file IoComponentMgr.cpp.

299 {
300
301 DEBMSG << "--> io_update(" << ioc->name() << "," << old_fname << "," << new_fname << ")" << endmsg;
302
303 IoDict_t::iterator it;
304 for ( it = m_cdict.equal_range( ioc ).first; it != m_cdict.equal_range( ioc ).second; ++it ) {
305
306 if ( it->second.m_oldfname == old_fname ) {
307 DEBMSG << "updating " << ioc->name() << " f: " << old_fname << " -> " << new_fname << endmsg;
308 it->second.m_newfname = new_fname;
309 return StatusCode::SUCCESS;
310 }
311 }
312
313 return StatusCode::FAILURE;
314 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
StatusCode::FAILURE
Definition: StatusCode.h:29
std::multimap::equal_range
T equal_range(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

StatusCode IoComponentMgr::io_update | ( | IIoComponent * | iocomponent,
|  | const std::string & | work_dir
| ) |  |
| override

: allow a `IIoComponent` to update the contents of the registry with a new work directory

Definition at line 318 of file IoComponentMgr.cpp.

319 {
320
321 DEBMSG << "--> io_update(" << ioc->name() << "," << work_dir << ")" << endmsg;
322
323 IoDict_t::iterator it;
324 for ( it = m_cdict.equal_range( ioc ).first; it != m_cdict.equal_range( ioc ).second; ++it ) {
325
326 switch ( it->second.m_iomode ) {
327 case IIoComponentMgr::IoMode::READ: {
328 it->second.m_newfname = it->second.m_oldabspath;
329 break;
330 }
331 case IIoComponentMgr::IoMode::WRITE: {
332 boost::filesystem::path oldPath( it->second.m_oldfname );
333 if ( oldPath.is_relative() && oldPath.filename() == oldPath.relative_path() ) {
334
335 // Only file name was provided for writing. This is the usual mode of operation
336 // ***
337 // NB. In such cases it would make sense to set newfname=oldfname, however this will break
338 // existing client codes, which assume that newfname contains "/"
339 // Thus we set newfname=workdir/oldfname
340 // ***
341
342 boost::filesystem::path newfname( work_dir );
343 newfname /= oldPath;
344 it->second.m_newfname = newfname.string();
345 } else {
346 // New name should be the old absolute path
347 it->second.m_newfname = it->second.m_oldabspath;
348 }
349
350 break;
351 }
352 default: {
353 // Don't know how to deal with either RW or INVALID
354 error() << "Unable to update IoComponent for the mode " << it->second.m_iomode << endmsg;
355 return StatusCode::FAILURE;
356 }
357 }
358
359 } // for
360
361 return StatusCode::SUCCESS;
362 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
GaudiPython.HistoUtils.path
path
Definition: HistoUtils.py:895
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StatusCode::FAILURE
Definition: StatusCode.h:29
IIoComponentMgr::IoMode::WRITE
Definition: IIoComponentMgr.h:32
IIoComponentMgr::IoMode::READ
Definition: IIoComponentMgr.h:32
std::multimap::equal_range
T equal_range(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

StatusCode IoComponentMgr::io_update_all | ( | const std::string & | work_dir | ) |
| override

: Update all `IIoComponents` with a new work directory

Definition at line 366 of file IoComponentMgr.cpp.

367 {
368 DEBMSG << "-->io_update_all for the directory " << work_dir << endmsg;
369 bool allgood = true;
370 for ( IoStack_t::iterator io = m_iostack.begin(), ioEnd = m_iostack.end(); io != ioEnd; ++io ) {
371 if ( !io_update( *io, work_dir ).isSuccess() ) {
372 allgood = false;
373 error() << "problem in [" << ( *io )->name() << "]->io_update() !" << endmsg;
374 }
375 }
376 return allgood ? StatusCode::SUCCESS : StatusCode::FAILURE;
377 }
StatusCode::SUCCESS
Definition: StatusCode.h:29
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:50
std::list::end
T end(T...args)
DEBMSG
#define DEBMSG
Definition: IoComponentMgr.cpp:25
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
IoComponentMgr::io_update
StatusCode io_update(IIoComponent *iocomponent, const std::string &old_fname, const std::string &new_fname) override
: allow a IIoComponent to update the contents of the registry with a new file name ...
Definition: IoComponentMgr.cpp:298
std::list::begin
T begin(T...args)
StatusCode::FAILURE
Definition: StatusCode.h:29
IoComponentMgr::m_iostack
IoStack_t m_iostack
Stack of IIoComponents to properly handle order of registration.
Definition: IoComponentMgr.h:172
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

std::string IoComponentMgr::list | ( |  | ) | const
| private

Definition at line 444 of file IoComponentMgr.cpp.

445 {
446
447 ostringstream ost;
448
449 ost << "Listing all IoComponents (" << m_cdict.size() << "): " << endl;
450 for ( const auto& i : m_cdict ) {
451 ost << " " << i.first->name() << " " << i.second << endl;
452 }
453
454 return ost.str();
455 }
std::endl
T endl(T...args)
std::ostringstream
STL class.
std::ostringstream::str
T str(T...args)
std::multimap::size
T size(T...args)
IoComponentMgr::m_cdict
IoDict_t m_cdict
Definition: IoComponentMgr.h:178

## Member Data Documentation

IoDict_t IoComponentMgr::m_cdict
| private

Definition at line 178 of file IoComponentMgr.h.

std::string IoComponentMgr::m_dict_location
| private

location of the python dictionary

Definition at line 181 of file IoComponentMgr.h.

IoRegistry_t IoComponentMgr::m_ioregistry
| private

Registry of `IIoComponents`.

Definition at line 168 of file IoComponentMgr.h.

IoStack_t IoComponentMgr::m_iostack
| private

Stack of `IIoComponents` to properly handle order of registration.

Definition at line 172 of file IoComponentMgr.h.

The documentation for this class was generated from the following files:

- GaudiMP/src/component/IoComponentMgr.h
- GaudiMP/src/component/IoComponentMgr.cpp